require "sms_voice_flash/version"
require 'rest-client'
require 'json'

module SmsVoiceFlash

  extend self

  #短信
  SmsSendUrl   = "https://k.ylb.io/api/message/v0/send"
  SmsReportUrl = "https://k.ylb.io/api/message/v0/report"

  #语音
  IvrSendUrl   = "https://k.ylb.io/api/ivr/v0/send"
  SmsReportUrl = "https://k.ylb.io/api/ivr/v0/report"

  #闪信
  FlashSendUrl   = "https://k.ylb.io/api/flash/v0/send"
  FlashReportUrl = "https://k.ylb.io/api/flash/v0/report"

  def set key,sign="云喇叭"
    @key = key
    @sign = sign
  end

  def send send_type,mobile,content
    #如果用户输入的为数组，则将数组内的元素用逗号分隔成字符串
    if mobile.kind_of?(Array)
      mobile = mobile.map{|number| number.strip}.join(",")
    end
    url = URI.encode("#{Object.const_get(send_type+"SendUrl")}?apikey=#{@key}&mobile=#{mobile}&content=#{content}&ts=#{Time.now.to_i}&sign=#{@sign}")
    JSON.parse(RestClient.get(url).body,object_class: OpenStruct)
  end

  def report send_type
    url = URI.encode("#{Object.const_get(send_type + "ReportUrl")}?apikey=#{@key}")
    JSON.parse(RestClient.get(url).body,object_class: OpenStruct)
  end

end
